//+------------------------------------------------------------------+
//|                                                       TimeSelect |
//|                                                  Modified by cja | 
//| ---------------------------------------------------------------- | 
//|                                                LNX_Pivots_v2.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |                                                                  
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
//---- input parameters
extern int   TotalDays   = 5;
extern int   SetHour     = 12;
extern int   SetMinute   = 00;
extern color LineColor   = Red;
extern int   LineStyle   = 0;
extern int   LineWidth   = 2;
extern bool  SetLine_atClose    = true;
extern bool  SetLine_BackGround = false;
extern bool  SetLineLong        = false;

//---- indicator buffers
double range[];
double time[];

datetime time1;
datetime time2;
datetime Set_time[];

int shift, num;
int Time_shift[];
bool FirstTime = true;   
int PlotDay=0;

// ----
void ObjDel()
{
   if (ObjectsTotal() > 0)
   for (num=0;num<=TotalDays;num++)
   {
   ObjectDelete("TIME["+num+"]"+SetHour+SetMinute);
  
   }
}
// ----
void PlotLine(string name,double value,double line_color,double style)
{
   bool res = ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
   ObjectSet(name, OBJPROP_WIDTH,LineWidth);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY, SetLineLong);
   ObjectSet(name, OBJPROP_BACK, SetLine_BackGround);
   ObjectSet(name, OBJPROP_COLOR, line_color);
}        
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   FirstTime = true;
   
   IndicatorBuffers(1);
   SetIndexBuffer(0,time);
   
   return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+   
int deinit()
{
   ObjDel();
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
//| TimeSelect                                                       |
//+------------------------------------------------------------------+
int start()
{
   int i;
   double T;
      
   if (!FirstTime || PlotDay == TimeDayOfYear(TimeCurrent())) return(0); 
   
   ArrayResize(Set_time,TotalDays+20+1);
   ArrayResize(Time_shift,TotalDays+20+1);
     
   for (shift=0;shift<=TotalDays;shift++)
   {
   Set_time[shift]  = iTime(NULL,PERIOD_D1,shift) + (SetHour)*3600 + (SetMinute)*60;
   Time_shift[shift] = iBarShift(NULL,0,Set_time[shift]);
   if(SetLine_atClose){
   time[shift] = iClose(NULL,0,Time_shift[shift]);}
   else{
   time[shift] = iOpen(NULL,0,Time_shift[shift]);}        
   }
    
   for (shift=0;shift<=TotalDays;shift++)
   {
   int length = Time_shift[shift+1]-Time_shift[shift];
   double high = High[iHighest(NULL,0,MODE_HIGH,length,Time_shift[shift])];
   double low  = Low[iLowest(NULL,0,MODE_LOW,length,Time_shift[shift])];
   }
  
   for (shift=0;shift<=TotalDays;shift++)
   {
   
   T  = time[shift];
  

      if (shift<=TotalDays-1)
      {     
      time1 = Set_time[shift];    
      i=shift-1;
      if (shift==0) 
      time2 = Set_time[shift] + 24*60/Period()*3600 ;
      else
      time2 = Set_time[shift-1];
   
      
      PlotLine("TIME["+shift+"]"+SetHour+SetMinute,T,LineColor,LineStyle);
          
      FirstTime = false;
      PlotDay = TimeDayOfYear(Set_time[0]);
 
      }
   }
   return(0);
}
//+------------------------------------------------------------------+